<template>
  <div class="dog-form">
    <div class="row justify-between">
      <div class="col-3 dog-form__input-wrapper">
        <q-input
          name="name"
          :error="errors.has('name')"
          v-model="internalValue.name"
          v-validate="'required'"
          placeholder="Meno"
          @focus="focus = true"
          @blur="focus = false"
        />
      </div>
      <div class="col-3 dog-form__input-wrapper">
        <q-input
          name="age"
          :error="errors.has('age')"
          v-model="internalValue.age"
          v-validate="'required'"
          placeholder="Vek"
          type="number"
          @focus="focus = true"
          @blur="focus = false"
        />
      </div>
      <div class="col-3 dog-form__input-wrapper">
        <q-select
          name="breed"
          :error="errors.has('breed')"
          v-model="internalValue.breed"
          :options="breeds"
          placeholder="Plemeno"
          @focus="focus = true"
          @blur="focus = false"
        />
      </div>
      <div class="col-3 dog-form__input">
        <q-datetime
          name="availableFrom"
          v-model="internalValue.availableFrom"
          type="time"
          :error="errors.has('availableFrom')"
          placeholder="Dostupný od"
          @focus="focus = true"
          @blur="focus = false"
        />
        <q-datetime
          name="availableTo"
          v-model="internalValue.availableTo"
          type="time"
          :error="errors.has('availableTo')"
          placeholder="Dostupný do"
          @focus="focus = true"
          @blur="focus = false"
        />
      </div>
    </div>
    <div class="add-button ">
      <q-btn flat dense color="primary" @click="action">
        <q-icon name="add" />
        Uložiť
      </q-btn>
    </div>
  </div>
</template>

<style lang="scss">
  .dog-form {
    &__input-wrapper {
      padding: 0 0.5rem;
    }
  }
</style>

<script>
export default {
  name: 'DogForm',

  props: {
    value: Object,
    id: Number,
    action: Function
  },

  $_veeValidate: {
    validator: 'new'
  },

  data () {
    return {
      breeds: [
        {
          label: 'Čivava',
          value: 'chihuahua'
        },
        {
          label: 'Dalmatínec',
          value: 'dalmatian'
        },
        {
          label: 'Pudel',
          value: 'poodle'
        },
        {
          label: 'Rotvajler',
          value: 'rottweiler'
        },
        {
          label: 'Sibírsky husky',
          value: 'husky'
        },
        {
          label: 'Zlatý retríver',
          value: 'retriever'
        }
      ]
    }
  },

  computed: {
    internalValue: {
      get () { return this.value },
      set (v) { this.$emit('input', v) }
    }
  },

  methods: {
    saveOrUpdate: function () {
      if (this.id) {
        this.$store.dispatch('dogs/createDog')
      }
    }
  }
}
</script>
